package com.kingdee.eas.custom.shuiyou.six.handler;

import cn.hutool.json.JSONConfig;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.rabbitmq.guava.Lists;
import com.kingdee.bos.sql.ParserException;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.shuiyou.incomeTax.TaxDirectDeductionExFacadeFactory;
import com.kingdee.eas.custom.shuiyou.six.osf.vo.SixTConfirmInfo;
import com.kingdee.eas.custom.shuiyou.six.osf.vo.SixTPersonInfo;
import com.kingdee.eas.custom.shuiyou.task.TaskCatalogEnum;
import com.kingdee.eas.custom.shuiyou.uitls.ISYUtilsFacade;

import com.kingdee.eas.custom.shuiyou.uitls.SYUtilsFacadeFactory;
import com.kingdee.eas.custom.shuiyou.uitls.URLConfigEnum;
import com.kingdee.eas.util.app.DbUtil;
import com.kingdee.jdbc.rowset.IRowSet;
import com.kingdee.shr.base.syssetting.app.filter.HRFilterUtils;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;

import com.kingdee.shr.compensation.app.tax.TaxUnitCollection;
import com.kingdee.shr.compensation.app.tax.TaxUnitFactory;
import com.kingdee.shr.compensation.app.tax.TaxUnitInfo;
import com.kingdee.shr.compensation.app.taxCal.*;

import com.kingdee.shr.compensation.util.Base64Utils;
import com.kingdee.shr.compensation.util.CmpDateUtil;
import com.kingdee.shr.compensation.util.CmpStrUtil;
import com.kingdee.shr.compensation.util.TaxReportUtil;

import com.kingdee.shr.compensation.util.lock.CmpDistributedLockUtils;
import com.kingdee.shr.compensation.web.handler.tax.TaxDirectDeductionListHandler;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.sql.Timestamp;
import java.util.*;

/**
 * 6ȷ
 * description: TaxDirectDeductionListHandlerEx <br>
 * date: 2024/8/28 14:42 <br>
 * author: lhbj <br>
 * version: 1.0 <br>
 */
public class TaxDirectDeductionListHandlerEx extends TaxDirectDeductionListHandler {
    private static final Logger LOG = Logger.getLogger(TaxDirectDeductionListHandler.class);

    public void specialAmountAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {


    }

    /**
     * ȡԱ
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void personCollectAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        String ids = request.getParameter("taxUnitIds");
        int thisYear = CmpDateUtil.getYear(new Date());
        Map<String, Object> map = new HashMap();
        map.put("taxUnitIds", ids);
        map.put("period", thisYear + "-01");
        try {

            List<IObjectPK> list = TaxDirectDeductionExFacadeFactory.getLocalInstance(ctx).staffCollection(map);
        } catch (BOSException var9) {
            LOG.error("staffCollection failed, caused by: ", var9);
            throw new ShrWebBizException(var9.getMessage());
        }
    }


    /**
     * ȷԱ
     * @param request
     * @param response
     * @param modelMap
     * @throws SHRWebException
     */
    public void personCollectConfirmAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws SHRWebException {
        Context ctx = SHRContext.getInstance().getContext();
        String selectedData = request.getParameter("selectedData");
        ArrayList ids = new ArrayList();

        try {
            String oql;
            if (StringUtils.isEmpty(selectedData)) {
                super.prepareQueryList(request, response, modelMap);
                EntityViewInfo defaultEntityViewInfo = (EntityViewInfo)modelMap.get("DataGridEntityView");
                oql = "select id, sate where " + defaultEntityViewInfo.getFilter().toSql();
            } else {
                oql = "select id, sate where id in " + CmpStrUtil.buildInSql(selectedData);
            }
            StringBuilder msg = this.checkBeforeConfirm(ctx, ids, oql);
            if(msg.length()>0) {
                throw new BOSException(msg.toString());
            }else {
                int lastYear = CmpDateUtil.getYear(new Date());
                Map<String, Object> map = new HashMap();
                map.put("ids", ids);
                map.put("period", lastYear + "-01");
                TaxDirectDeductionExFacadeFactory.getLocalInstance(ctx).confirm(map);
            }
        } catch (Exception var10) {
            var10.printStackTrace();
            LOG.error("TaxDirectDeduction confirm failed, caused by: ", var10);
            throw new ShrWebBizException(var10.getMessage());
        }
    }

    /**
     * УѡǷѾȷ
     * @param ctx
     * @param ids
     * @param oql
     * @return
     * @throws BOSException
     */
    protected StringBuilder checkBeforeConfirm(Context ctx, List<String> ids, String oql) throws BOSException {
        StringBuilder msg = new StringBuilder();
        TaxDirectDeductionCollection collection = TaxDirectDeductionFactory.getLocalInstance(ctx).getTaxDirectDeductionCollection(oql);
        if (collection != null && !collection.isEmpty()) {
            for(int i = 0; i < collection.size(); ++i) {
                TaxDirectDeductionInfo info = collection.get(i);
                if (info.getSate() == TaxDeductionStateEnum.CONFIRMING || info.getSate() == TaxDeductionStateEnum.CONFIRMED) {
                    msg.append("벻ҪԡȷϡȷСԱٴηȷϡ");
                }

                ids.add(info.getId().toString());
            }

        } else {
            msg.append("ǰѡ޿ȷԱȵýӿ[ȡԱ]ɹٽȷ");
        }
        return msg;
    }



    /**
     * ȡ˰λ鼯¼
     * @param collection
     * @return
     */
    protected Map<String, List<TaxDirectDeductionInfo>> groupByTaxUnit(TaxDirectDeductionCollection collection) {
        Map<String, List<TaxDirectDeductionInfo>> map = new HashMap();

        for(int i = 0; i < collection.size(); ++i) {
            TaxDirectDeductionInfo info = collection.get(i);
            String taxUnitDeductionId = info.getTaxUnitDeduction().getId().toString();
            List<TaxDirectDeductionInfo> list = (List)map.get(taxUnitDeductionId);
            if (null == list) {
                list = new ArrayList();
            }

            ((List)list).add(info);
            map.put(taxUnitDeductionId, list);
        }

        return map;
    }
    protected Map<String, String> getAcceptIdMap(Context ctx, Map<String, List<TaxDirectDeductionInfo>> groups) throws BOSException {
        try {
            String sql = "select t3.fAccept_id acceptId, t1.fid fid from t_hr_sTaxUnitDeduction t1, T_HR_STaskIncomeTaxRelation t2, t_hr_sTaxCalTask t3 where t1.fid = t2.fBizId and t2.fTaskId = t3.fid and t1.fid in (" + CmpStrUtil.convertSetToSqlString(groups.keySet()) + ")";
            Map<String, String> acceptIdMap = new HashMap();
            IRowSet rs = DbUtil.executeQuery(ctx, sql);

            while(rs.next()) {
                String key = rs.getString("fid");
                String acceptId = rs.getString("acceptId");
                acceptIdMap.put(key, acceptId);
            }

            return acceptIdMap;
        } catch (Exception var8) {
            LOG.error("getAcceptIdMap error: ", var8);
            throw new BOSException(var8.getMessage());
        }
    }
}
